export default class MutableContext {
    constructor(initialValue) {
        this.value = initialValue;
        this.callbacks = new Set();
    }
    getValue() {
        return [this.value, (newValue) => this.setValue(newValue)];
    }
    subscribe(callback) {
        this.callbacks.add(callback);
    }
    unsubscribe(callback) {
        this.callbacks.delete(callback);
    }
    setValue(newValue) {
        this.value = newValue;
        this.callbacks.forEach((callback) => callback());
    }
}
