import { createContext, createElement, useContext, useEffect, useState } from 'react';
import MutableContext from './MutableContext';
export function createMutableContext(initialValue) {
    const context = new MutableContext(initialValue);
    const reactContext = createContext(context.getValue());
    function MutableContextProvider(props) {
        const [value, setValue] = useState(() => context.getValue());
        useEffect(() => {
            const cb = () => {
                setValue(context.getValue());
            };
            context.subscribe(cb);
            return () => context.unsubscribe(cb);
        }, []);
        return createElement(reactContext.Provider, { value }, props.children);
    }
    function useMutableContext() {
        return useContext(reactContext);
    }
    return {
        Provider: MutableContextProvider,
        use: useMutableContext
    };
}
