"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const MutableContext_1 = require("./MutableContext");
function createMutableContext(initialValue) {
    const context = new MutableContext_1.default(initialValue);
    const reactContext = react_1.createContext(context.getValue());
    function MutableContextProvider(props) {
        const [value, setValue] = react_1.useState(() => context.getValue());
        react_1.useEffect(() => {
            const cb = () => {
                setValue(context.getValue());
            };
            context.subscribe(cb);
            return () => context.unsubscribe(cb);
        }, []);
        return react_1.createElement(reactContext.Provider, { value }, props.children);
    }
    function useMutableContext() {
        return react_1.useContext(reactContext);
    }
    return {
        Provider: MutableContextProvider,
        use: useMutableContext
    };
}
exports.createMutableContext = createMutableContext;
